package sun.awt.motif;

import java.awt.Color;
import java.awt.Component;
import java.awt.Dialog;
import java.awt.Font;
import java.awt.Insets;
import java.awt.Window;
import java.awt.event.ComponentEvent;
import java.awt.event.WindowEvent;
import java.awt.peer.DialogPeer;
import java.util.Vector;
import sun.awt.Modality;

class MDialogPeer extends MPanelPeer implements DialogPeer {
   Insets insets;
   static Vector allDialogs = new Vector();
   Modality m_modality;

   native void create(MComponentPeer var1, Object var2);

   native void pSetTitle(String var1);

   native void pShow();

   native void pHide();

   native void pReshape(int var1, int var2, int var3, int var4);

   native void pDispose();

   public native void setResizable(boolean var1);

   native void addTextComponent();

   MDialogPeer(Dialog var1) {
      super(var1, new Insets(Integer.getInteger("awt.frame.topInset", 25), Integer.getInteger("awt.frame.leftInset", 5), Integer.getInteger("awt.frame.bottomInset", 5), Integer.getInteger("awt.frame.rightInset", 5)));
      allDialogs.addElement(this);
      if (var1.getTitle() != null) {
         this.pSetTitle(var1.getTitle());
      }

      Font var2 = ((Component)var1).getFont();
      if (var2 == null) {
         var2 = new Font("Dialog", 0, 12);
         ((Component)var1).setFont(var2);
         ((MComponentPeer)this).setFont(var2);
      }

      Color var3 = ((Component)var1).getBackground();
      if (var3 == null) {
         ((Component)var1).setBackground(Color.lightGray);
         ((MComponentPeer)this).setBackground(Color.lightGray);
      }

      var3 = ((Component)var1).getForeground();
      if (var3 == null) {
         ((Component)var1).setForeground(Color.black);
         ((MComponentPeer)this).setForeground(Color.black);
      }

      this.setResizable(var1.isResizable());
   }

   public void setTitle(String var1) {
      this.pSetTitle(var1);
   }

   public void dispose() {
      allDialogs.removeElement(this);
      super.dispose();
   }

   public synchronized void handleMoved(int var1, int var2) {
      ((MComponentPeer)this).postEvent(new ComponentEvent(super.target, 100));
   }

   public void handleActivate() {
      ((MComponentPeer)this).postEvent(new WindowEvent((Window)super.target, 205));
   }

   public void handleDeactivate() {
      ((MComponentPeer)this).postEvent(new WindowEvent((Window)super.target, 206));
   }

   public void handleQuit() {
      ((MComponentPeer)this).postEvent(new WindowEvent((Window)super.target, 201));
   }

   public void show() {
      super.show();
      ((MComponentPeer)this).postEvent(new WindowEvent((Window)super.target, 200));
      if (((Dialog)super.target).isModal()) {
         try {
            this.m_modality = new Modality();
            this.m_modality.enter();
         } catch (InterruptedException var2) {
            ((Dialog)super.target).hide();
         } catch (ThreadDeath var3) {
            ((Dialog)super.target).hide();
            ((Dialog)super.target).removeNotify();
            throw (ThreadDeath)((Throwable)var3).fillInStackTrace();
         }
      }
   }

   public void hide() {
      super.hide();
      if (((Dialog)super.target).isModal() && this.m_modality != null) {
         this.m_modality.exit();
      }

   }

   public void toFront() {
      this.pShow();
   }

   public native void toBack();

   public Insets insets() {
      return this.insets;
   }

   public synchronized void handleResize(int var1, int var2) {
      ((MComponentPeer)this).postEvent(new ComponentEvent(super.target, 101));
   }
}
