package sun.awt.motif;

import java.awt.AWTEvent;
import java.awt.MenuComponent;
import java.awt.MenuItem;
import java.awt.event.ActionEvent;
import java.awt.peer.MenuItemPeer;
import sun.awt.ObjectPeer;

class MMenuItemPeer extends ObjectPeer implements MenuItemPeer {
   int pData;
   boolean isCheckbox = false;
   MenuItem target;
   boolean nativeCreated = false;

   native void createMenuItem(MMenuPeer var1);

   void create(MMenuPeer var1) {
      if (var1.nativeCreated) {
         this.createMenuItem(var1);
         this.nativeCreated = true;
         this.setEnabled(this.target.isEnabled());
      }

   }

   protected MMenuItemPeer() {
   }

   MMenuItemPeer(MenuItem var1) {
      this.target = var1;
      MMenuPeer var2 = (MMenuPeer)MToolkit.targetToPeer(((MenuComponent)var1).getParent());
      this.create(var2);
   }

   public void setEnabled(boolean var1) {
      if (var1) {
         this.enable();
      } else {
         this.disable();
      }
   }

   public void setLabel(String var1) {
      if (this.nativeCreated) {
         this.pSetLabel(var1);
      }
   }

   native void pSetLabel(String var1);

   public void enable() {
      if (this.nativeCreated) {
         this.pEnable();
      }
   }

   native void pEnable();

   public void disable() {
      if (this.nativeCreated) {
         this.pDisable();
      }
   }

   native void pDisable();

   public void dispose() {
      if (this.nativeCreated) {
         this.pDispose();
         this.nativeCreated = false;
      }
   }

   native void pDispose();

   void postEvent(AWTEvent var1) {
      MToolkit.postEvent(var1);
   }

   public void action(long var1, int var3) {
      this.postEvent(new ActionEvent(this.target, 1001, this.target.getActionCommand(), var3));
   }
}
