package sun.awt.motif;

import java.awt.AWTEvent;
import java.awt.Button;
import java.awt.Canvas;
import java.awt.Checkbox;
import java.awt.CheckboxMenuItem;
import java.awt.Choice;
import java.awt.Component;
import java.awt.Container;
import java.awt.Dialog;
import java.awt.EventQueue;
import java.awt.FileDialog;
import java.awt.Font;
import java.awt.FontMetrics;
import java.awt.Frame;
import java.awt.Image;
import java.awt.Label;
import java.awt.List;
import java.awt.Menu;
import java.awt.MenuBar;
import java.awt.MenuItem;
import java.awt.Panel;
import java.awt.PopupMenu;
import java.awt.PrintJob;
import java.awt.ScrollPane;
import java.awt.Scrollbar;
import java.awt.TextArea;
import java.awt.TextField;
import java.awt.Toolkit;
import java.awt.Window;
import java.awt.datatransfer.Clipboard;
import java.awt.image.ColorModel;
import java.awt.image.ImageObserver;
import java.awt.image.ImageProducer;
import java.awt.peer.ButtonPeer;
import java.awt.peer.CanvasPeer;
import java.awt.peer.CheckboxMenuItemPeer;
import java.awt.peer.CheckboxPeer;
import java.awt.peer.ChoicePeer;
import java.awt.peer.DialogPeer;
import java.awt.peer.FileDialogPeer;
import java.awt.peer.FontPeer;
import java.awt.peer.FramePeer;
import java.awt.peer.LabelPeer;
import java.awt.peer.ListPeer;
import java.awt.peer.MenuBarPeer;
import java.awt.peer.MenuItemPeer;
import java.awt.peer.MenuPeer;
import java.awt.peer.PanelPeer;
import java.awt.peer.PopupMenuPeer;
import java.awt.peer.ScrollPanePeer;
import java.awt.peer.ScrollbarPeer;
import java.awt.peer.TextAreaPeer;
import java.awt.peer.TextFieldPeer;
import java.awt.peer.WindowPeer;
import java.util.EventObject;
import java.util.Properties;
import sun.awt.ObjectPeer;
import sun.awt.SunToolkit;
import sun.awt.image.ImageRepresentation;

public class MToolkit extends SunToolkit implements Runnable {
   static final boolean useMotifChoiceWidget = true;
   X11Clipboard clipboard;
   static ColorModel screenmodel;

   public MToolkit() {
      this.init();
      new InputThread();
      Thread var1 = new Thread(this, "AWT-Motif");
      var1.setDaemon(false);
      var1.start();
   }

   public native void init();

   public native void run();

   public ButtonPeer createButton(Button var1) {
      MButtonPeer var2 = new MButtonPeer(var1);
      SunToolkit.peerMap.put(var1, var2);
      return var2;
   }

   public TextFieldPeer createTextField(TextField var1) {
      MTextFieldPeer var2 = new MTextFieldPeer(var1);
      SunToolkit.peerMap.put(var1, var2);
      return var2;
   }

   public LabelPeer createLabel(Label var1) {
      MLabelPeer var2 = new MLabelPeer(var1);
      SunToolkit.peerMap.put(var1, var2);
      return var2;
   }

   public ListPeer createList(List var1) {
      MListPeer var2 = new MListPeer(var1);
      SunToolkit.peerMap.put(var1, var2);
      return var2;
   }

   public CheckboxPeer createCheckbox(Checkbox var1) {
      MCheckboxPeer var2 = new MCheckboxPeer(var1);
      SunToolkit.peerMap.put(var1, var2);
      return var2;
   }

   public ScrollbarPeer createScrollbar(Scrollbar var1) {
      MScrollbarPeer var2 = new MScrollbarPeer(var1);
      SunToolkit.peerMap.put(var1, var2);
      return var2;
   }

   public ScrollPanePeer createScrollPane(ScrollPane var1) {
      MScrollPanePeer var2 = new MScrollPanePeer(var1);
      SunToolkit.peerMap.put(var1, var2);
      return var2;
   }

   public TextAreaPeer createTextArea(TextArea var1) {
      MTextAreaPeer var2 = new MTextAreaPeer(var1);
      SunToolkit.peerMap.put(var1, var2);
      return var2;
   }

   public ChoicePeer createChoice(Choice var1) {
      Object var2 = null;
      MChoicePeer var3 = new MChoicePeer(var1);
      SunToolkit.peerMap.put(var1, var3);
      return var3;
   }

   public FramePeer createFrame(Frame var1) {
      MFramePeer var2 = new MFramePeer(var1);
      SunToolkit.peerMap.put(var1, var2);
      return var2;
   }

   public CanvasPeer createCanvas(Canvas var1) {
      MCanvasPeer var2 = new MCanvasPeer(var1);
      SunToolkit.peerMap.put(var1, var2);
      return var2;
   }

   public PanelPeer createPanel(Panel var1) {
      MPanelPeer var2 = new MPanelPeer(var1);
      SunToolkit.peerMap.put(var1, var2);
      return var2;
   }

   public WindowPeer createWindow(Window var1) {
      MWindowPeer var2 = new MWindowPeer(var1);
      SunToolkit.peerMap.put(var1, var2);
      return var2;
   }

   public DialogPeer createDialog(Dialog var1) {
      MDialogPeer var2 = new MDialogPeer(var1);
      SunToolkit.peerMap.put(var1, var2);
      return var2;
   }

   public FileDialogPeer createFileDialog(FileDialog var1) {
      MFileDialogPeer var2 = new MFileDialogPeer(var1);
      SunToolkit.peerMap.put(var1, var2);
      return var2;
   }

   public MenuBarPeer createMenuBar(MenuBar var1) {
      MMenuBarPeer var2 = new MMenuBarPeer(var1);
      SunToolkit.peerMap.put(var1, var2);
      return var2;
   }

   public MenuPeer createMenu(Menu var1) {
      MMenuPeer var2 = new MMenuPeer(var1);
      SunToolkit.peerMap.put(var1, var2);
      return var2;
   }

   public PopupMenuPeer createPopupMenu(PopupMenu var1) {
      MPopupMenuPeer var2 = new MPopupMenuPeer(var1);
      SunToolkit.peerMap.put(var1, var2);
      return var2;
   }

   public MenuItemPeer createMenuItem(MenuItem var1) {
      MMenuItemPeer var2 = new MMenuItemPeer(var1);
      SunToolkit.peerMap.put(var1, var2);
      return var2;
   }

   public CheckboxMenuItemPeer createCheckboxMenuItem(CheckboxMenuItem var1) {
      MCheckboxMenuItemPeer var2 = new MCheckboxMenuItemPeer(var1);
      SunToolkit.peerMap.put(var1, var2);
      return var2;
   }

   public MEmbeddedFramePeer createEmbeddedFrame(MEmbeddedFrame var1, int var2) {
      MEmbeddedFramePeer var3 = new MEmbeddedFramePeer(var1, var2);
      SunToolkit.peerMap.put(var1, var3);
      return var3;
   }

   public FontPeer getFontPeer(String var1, int var2) {
      return new MFontPeer(var1, var2);
   }

   static native ColorModel makeColorModel();

   static ColorModel getStaticColorModel() {
      if (screenmodel == null) {
         screenmodel = makeColorModel();
      }

      return screenmodel;
   }

   public ColorModel getColorModel() {
      return getStaticColorModel();
   }

   public native int getScreenResolution();

   protected native int getScreenWidth();

   protected native int getScreenHeight();

   public FontMetrics getFontMetrics(Font var1) {
      return X11FontMetrics.getFontMetrics(var1);
   }

   public native void sync();

   static boolean prepareScrImage(Image var0, int var1, int var2, ImageObserver var3) {
      if (var1 != 0 && var2 != 0) {
         X11Image var4 = (X11Image)var0;
         if (((sun.awt.image.Image)var4).hasError()) {
            if (var3 != null) {
               var3.imageUpdate(var0, 192, -1, -1, -1, -1);
            }

            return false;
         } else {
            ImageRepresentation var5 = var4.getImageRep();
            return var5.prepare(var3);
         }
      } else {
         return true;
      }
   }

   static int checkScrImage(Image var0, int var1, int var2, ImageObserver var3) {
      X11Image var4 = (X11Image)var0;
      int var5;
      if (var1 != 0 && var2 != 0) {
         var5 = var4.getImageRep().check(var3);
      } else {
         var5 = 32;
      }

      return ((sun.awt.image.Image)var4).check(var3) | var5;
   }

   public int checkImage(Image var1, int var2, int var3, ImageObserver var4) {
      return checkScrImage(var1, var2, var3, var4);
   }

   public boolean prepareImage(Image var1, int var2, int var3, ImageObserver var4) {
      return prepareScrImage(var1, var2, var3, var4);
   }

   public Image createImage(ImageProducer var1) {
      return new X11Image(var1);
   }

   public PrintJob getPrintJob(Frame var1, String var2, Properties var3) {
      SecurityManager var4 = System.getSecurityManager();
      if (var4 != null) {
         var4.checkPrintJobAccess();
      }

      PSPrintControl var5 = new PSPrintControl(var1);
      return var5.initJob(var2, var3, true);
   }

   public native void beep();

   public Clipboard getSystemClipboard() {
      SecurityManager var1 = System.getSecurityManager();
      if (var1 != null) {
         var1.checkSystemClipboardAccess();
      }

      if (this.clipboard == null) {
         this.clipboard = new X11Clipboard("System");
      }

      return this.clipboard;
   }

   public native void loadSystemColors(int[] var1);

   public static Container getNativeContainer(Component var0) {
      return Toolkit.getNativeContainer(var0);
   }

   static void postEvent(AWTEvent var0) {
      EventQueue var1 = SunToolkit.theEventQueue;
      Object var2 = ((EventObject)var0).getSource();
      if (var2 != null) {
         Object var3 = SunToolkit.targetToPeer(var2);
         if (var3 != null && ((ObjectPeer)var3).getEventQueue() != null) {
            var1 = ((ObjectPeer)var3).getEventQueue();
         }
      }

      var1.postEvent(var0);
   }

   public static final Object targetToPeer(Object var0) {
      return SunToolkit.targetToPeer(var0);
   }

   public static final void targetDisposedPeer(Object var0, Object var1) {
      SunToolkit.targetDisposedPeer(var0, var1);
   }

   protected static native boolean awtInMozilla();

   static {
      SecurityManager.enablePrivilege("UniversalLinkAccess");
      System.loadLibrary("awt");
      SecurityManager.revertPrivilege();
   }
}
