package sun.awt.motif;

import java.awt.Font;
import java.awt.FontMetrics;
import java.io.CharConversionException;
import java.util.Hashtable;
import sun.awt.CharsetString;
import sun.awt.FontDescriptor;
import sun.awt.PlatformFont;

class X11FontMetrics extends FontMetrics {
   int[] widths;
   int ascent;
   int descent;
   int leading;
   int height;
   int maxAscent;
   int maxDescent;
   int maxHeight;
   int maxAdvance;
   static Hashtable table = new Hashtable();

   public X11FontMetrics(Font var1) {
      super(var1);
      this.init();
   }

   public int getLeading() {
      return this.leading;
   }

   public int getAscent() {
      return this.ascent;
   }

   public int getDescent() {
      return this.descent;
   }

   public int getHeight() {
      return this.height;
   }

   public int getMaxAscent() {
      return this.maxAscent;
   }

   public int getMaxDescent() {
      return this.maxDescent;
   }

   public int getMaxAdvance() {
      return this.maxAdvance;
   }

   public int stringWidth(String var1) {
      return this.charsWidth(var1.toCharArray(), 0, var1.length());
   }

   public int charsWidth(char[] var1, int var2, int var3) {
      Font var4 = ((FontMetrics)this).getFont();
      PlatformFont var5 = (PlatformFont)var4.getPeer();
      if (var5.mightHaveMultiFontMetrics()) {
         return this.getMFStringWidth(var1, var2, var3, var4, var5);
      } else if (this.widths == null) {
         return this.maxAdvance * var3;
      } else {
         int var6 = 0;

         for(int var7 = var2; var7 < var2 + var3; ++var7) {
            char var8 = var1[var7];
            if (var8 >= 0 && var8 < this.widths.length) {
               var6 += this.widths[var8];
            } else {
               var6 += this.maxAdvance;
            }
         }

         return var6;
      }
   }

   private int getMFStringWidth(char[] var1, int var2, int var3, Font var4, PlatformFont var5) {
      int var6 = 0;
      CharsetString[] var7 = var5.makeMultiCharsetString(var1, var2, var3);
      int var8 = 0;

      for(int var9 = 0; var9 < var7.length; ++var9) {
         int var10 = var7[var9].fontDescriptor.fontCharset.getMaxBytesPerChar() * var7[var9].length;
         if (var8 < var10) {
            var8 = var10;
         }
      }

      if (var8 == 0) {
         return 0;
      } else {
         byte[] var15 = new byte[var8];

         for(int var11 = 0; var11 < var7.length; ++var11) {
            CharsetString var12 = var7[var11];

            try {
               int var13 = var12.fontDescriptor.fontCharset.convert(var12.charsetChars, var12.offset, var12.offset + var12.length, var15, 0, var15.length);
               var6 += this.getMFCharSegmentWidth(var4, var12.fontDescriptor, var15, var13);
            } catch (CharConversionException var14) {
            }
         }

         return var6;
      }
   }

   private native int getMFCharSegmentWidth(Font var1, FontDescriptor var2, byte[] var3, int var4);

   public native int bytesWidth(byte[] var1, int var2, int var3);

   public int[] getWidths() {
      return this.widths;
   }

   native void init();

   static synchronized FontMetrics getFontMetrics(Font var0) {
      Object var1 = (FontMetrics)table.get(var0);
      if (var1 == null) {
         table.put(var0, var1 = new X11FontMetrics(var0));
      }

      return (FontMetrics)var1;
   }
}
